!This is supplementary material for the paper titled ``Statistical Process Control Using Dynamic Sampling Scheme''
!This programe can give AATS

program main
use imsl
implicit none

integer,parameter::w=50,simutime=1000,m=2000,asimutime=10
real,parameter::h=0.02500,g=0.54297,d1=.1,d2=1.9
real,parameter::tarl=400.,r=0.2,deltam=0.05,a=0.,b=3.37109
integer i,j,count,rl,mb,hcount,avei,shiftcount
real x,c,shift,shift1(10),p1,p2,p,ts,ats,arl,sortedc(100000),z(m),xbar,std,sdts,sdrl,h1(10),k,aarl,sdarl,aats,sdats,delta,h2

h1=(/0.001,0.002,0.003,0.005,0.01,0.02,0.03,0.1,0.2,0.3/)
shift1=(/0.,0.05,0.1,0.2,0.4,0.6,0.8,1.0,1.5,2.0/)

open(10,file="data.txt",status="old",position="append")


write(*,"('m='i4,x,'w='i3,x,'r='f4.2,x,'deltamin='f4.2,x,'d1='f4.2,x,'d2='f4.2,x,'h='f5.3,x,'g='f5.3)")m,w,r,deltam,d1,d2,h,g
write(10,"('m='i4,x,'w='i3,x,'r='f4.2,x,'deltamin='f4.2,x,'d1='f4.2,x,'d2='f4.2,x,'h='f5.3,x,'g='f5.3)")m,w,r,deltam,d1,d2,h,g

!write(*,"('m='i4,x,'w='i3,x,'r='f4.2,x,'deltamin='f4.2,x,'a='f4.2,x,'b='f4.2,x,'h='f5.3)")m,w,r,deltam,a,b,h
!write(10,"('m='i4,x,'w='i3,x,'r='f4.2,x,'deltamin='f4.2,x,'a='f4.2,x,'b='f4.2,x,'h='f5.3)")m,w,r,deltam,a,b,h


do shiftcount=1,10
		shift=shift1(shiftcount)

aarl=0
sdarl=0
aats=0
sdats=0

do avei=1,asimutime




            !generate normal n(0,1)
			call rnnor(m,z)

call find_sortedcadaptive(m,z,w,tarl,r,deltam,sortedc)


	ats=0
    arl=0
	sdts=0
    sdrl=0	
	
    count=0	
    j=0	

	
	do while(j<simutime)
120       j=j+1
          ts=0
          rl=0
          p=1
		  c=0
		  delta=0

		    
		  
		  do while(p>h .and. rl<w)
            rl=rl+1
			
			!generate normal n(0,1)
			call rnnor(1,x)

             delta=max(deltam,(1.0-r)*delta+r*x)
			 k=delta/2.
             h2=log(1.0+2*tarl*k**2+2.332*k)/(2*k)-1.166   
			 c=max(0.0,c+(x-k)/h2)
             call find_pvalue(sortedc,c,p1,p2) 
		    p=(p1+p2)/2
          enddo

			if(rl==w)then
	         count=count+1
	        else
	         go to 120
	        end if

		    rl=0

           
		   do while(p>h .and. rl<100000)
		  
            rl=rl+1
            
			if(p>g)then
            ts=ts+d2
			else
		    ts=ts+d1
			endif
            
            !ts=ts+a+b*p*p

		   !generate normal n(0,1)
			call rnnor(1,x)
		
			x=x+shift
			 delta=max(deltam,(1.0-r)*delta+r*x)
			 k=delta/2.
             h2=log(1.0+2*tarl*k**2+2.332*k)/(2*k)-1.166   
			 c=max(0.0,c+(x-k)/h2)

            call find_pvalue(sortedc,c,p1,p2) 
		    p=(p1+p2)/2
           
           end do

	ats=ats+ts
    arl=arl+rl
	sdts=sdts+ts**2.
    sdrl=sdrl+rl**2.
	end do


	if(count<2)then
		write(*,"('Warning: the denominator is zero!')")
		write(10,"('Warning: the denominator is zero!')")
	else
		arl=arl/real(count)
		ats=ats/real(count)
		sdts=sqrt((sdts-count*ats**2.)/(count-1))
		sdrl=sqrt((sdrl-count*arl**2.)/(count-1))
		!write(*,"('shift='f4.2,x,'arl='f9.3,x,'sdrl='f9.3,x,'ats='f9.3,x,'sdts='f9.3)")shift,arl,sdrl,ats,sdts
		!write(10,"('shift='f4.2,x,'arl='f9.3,x,'sdrl='f9.3,x,'ats='f9.3,x,'sdts='f9.3)")shift,arl,sdrl,ats,sdts

		!write(*,"('shift='f4.2,x,'arl='f9.3,x,'sdrl='f9.3,x,'ats='f9.3,x,'sdts='f9.3)")shift,arl,sdrl,ats,sdts
		!write(10,"('shift='f4.2,x,'arl='f9.3,x,'sdrl='f9.3,x,'ats='f9.3,x,'sdts='f9.3)")shift,arl,sdrl,ats,sdts
	endif

aarl=aarl+arl
sdarl=sdarl+arl**2.
aats=aats+ats
sdats=sdats+ats**2.
enddo

aats=aats/real(asimutime)
aarl=aarl/real(asimutime)
sdats=sqrt((sdats-asimutime*aats**2.)/(asimutime-1))
sdarl=sqrt((sdarl-asimutime*aarl**2.)/(asimutime-1))

write(*,"('shift='f6.3,x,'aarl='f9.3,x,'sdarl='f9.3,x,'aats='f9.3,x,'sdats='f9.3)")shift,aarl,sdarl,aats,sdats
write(10,"('shift='f6.3,x,'aarl='f9.3,x,'sdarl='f9.3,x,'aats='f9.3,x,'sdats='f9.3)")shift,aarl,sdarl,aats,sdats
enddo

stop
end


subroutine find_sortedc(m,z,n,k,sortedc)
use imsl
implicit none

integer,parameter::simutime=100000
integer i,j,n,m,b
real x,c,sortedc(simutime),k,z(m),modify

	do j=1,simutime
 
		 c=0
    	  do i=1,n
		     !call rnnor(1,modify)
			 !modify=modify/10
			 call rnund(1,m,b)
			 !x=z(b)+modify
             x=z(b)
			 c=max(0.0,c+x-k)
		   end do
		  sortedc(j)=c
   
	end do

	   call quick_sort(sortedc,simutime)
	
return
end subroutine

subroutine find_sortedcadaptive(m,z,n,tarl,r,deltam,sortedc)
use imsl
implicit none

integer,parameter::simutime=100000
integer i,j,n,m,b
real x,c,sortedc(simutime),k,z(m),modify,tarl,r,deltam,delta,h1

	do j=1,simutime
 
		 delta=0
		 c=0
    	  do i=1,n
		     !call rnnor(1,modify)
			 !modify=modify/10
			 call rnund(1,m,b)
			 !x=z(b)+modify
             x=z(b)
			 delta=max(deltam,(1.0-r)*delta+r*x)
			 k=delta/2.
             h1=log(1.0+2*tarl*k**2+2.332*k)/(2*k)-1.166 
             c=max(0.0,c+(x-k)/h1) 
		   end do
		  sortedc(j)=c
   
	end do

	   call quick_sort(sortedc,simutime)
	
return
end subroutine

subroutine find_pvalue(sortedc,cn,pvalue1,pvalue2)
use imsl
implicit none

integer,parameter::simutime=100000,nq=1000
integer i
real sortedc(simutime),quantile(0:nq),cn,p,pvalue1,pvalue2

	quantile=100000   
	do i=1,nq
	   p=real(i)/nq
	   quantile(i)=sortedc(anint(p*simutime))
	   !if(abs(cn)<0.0000001)then
       !   pvalue1=1.
	   !   pvalue2=1.
	   !else
		   if(quantile(i-1)>cn .and. cn>=quantile(i))then
			pvalue1=(i-1.)/nq
			pvalue2=real(i)/nq
		   endif
	   !endif   	
	enddo

return
end subroutine

subroutine quick_sort(a,n)
implicit none
integer i,j,n 
real:: a(n),t	

do i=n-1,1,-1
 do j=1,i
  if(a(j)<a(j+1))then
  t=a(j)
  a(j)=a(j+1)
  a(j+1)=t
  end if
 end do
end do
return
end subroutine
